Problem decydowania, czy monotoniczny CNF implikuje monotoniczny DNF


14

Rozważ następujący problem decyzyjny

Wejście : monotoniczny CNF Φ i monotonowy DNFΨ .

Pytanie : Czy Φ→Ψ jest tautologią?

Zdecydowanie możesz rozwiązać ten problem w czasie O(2n⋅poly(l)) , gdzie n jest liczbą zmiennych w Φ→Ψ a l jest długością wejściową. Z drugiej strony ten problem jest kompletny coNP. Ponadto zmniejszenie który ustala CONP-kompletności także pokazuje, że jeśli nie SETH zawiedzie, ma O(2(1/2−ε)npoly(l))algorytm czasu dla tego problemu (dotyczy to każdego dodatniego ε ). Oto ta redukcja. Niech A będzie (nie-monotonicznym) CNF i niech x będzie jego zmienną. Zamień każde dodatnie wystąpienie x na y i każde ujemne wystąpienie x na z . Zrób to samo dla każdej zmiennej. Niech powstały monotoniczny CNF będzie Φ . Łatwo zauważyć, że A jest satysfakcjonujące, jeśli Φ→yz∨… nie jest tautologią. Ta redukcja wysadza liczbę zmiennych 2 razy, co implikuje 2n/2 (Na podstawie SETH) dolna granica wspomniana powyżej.

Jest więc różnica między 2n/2 a 2n time. Moje pytanie brzmi, czy znany jest lepszy algorytm lub lepsza redukcja od SETH?

Tylko dwie uwagi pozornie związane z problemem:

  • odwrotny problem, czy monotonowy DNF implikuje monotoniczny CNF, można w prosty sposób rozwiązać w czasie wielomianowym.

  • co ciekawe, problem decydowania, czy Φ i Ψ obliczą tę samą funkcję, można rozwiązać w quasi-wielomianowym czasie dzięki Fredmanowi i Khachiyanowi (O złożoności dualizacji monotonicznych dysjunkcyjnych normalnych form, Journal of Algorithms 21 (1996), nr 3 , ss. 618–628, doi: 10.1006 / jagm.1996.0062 )

Odpowiedzi:


6

Zakładając SETH, problemu nie da się rozwiązać w czasie dla dowolnego ϵ > 0 .O(2(1−ϵ)npoly(l))ϵ>0


Po pierwsze, pokażę, że dotyczy to bardziej ogólnego problemu, w którym i Ψ mogą być dowolnymi formułami monotonicznymi. W tym przypadku występuje wieloczynnikowa redukcja ctt od TAUT do problemu, który zachowuje liczbę zmiennych. Niech T n t ( x 0 , … , x n - 1 ) oznacza funkcję progową T n t ( x 0 , … , x n - 1 ) = 1ΦΨTtn(x0,…,xn−1) Użycie sieci Ajtai-Komlós-Szemerédi komparatorówT N T może być utworzona przez wielomian wielkości monotonicznej wzorze konstruowalne w czasieP°lr(n).

Ttn(x0,…,xn−1)=1⟺|{i<n:xi=1}|≥t.
Ttnpoly(n)

Biorąc pod uwagę wzór boolowski , możemy użyć reguł De Morgana, aby zapisać go w postaci ϕ ′ ( x 0 , … , x n - 1 , ¬ x 0 , … , ¬ x n - 1 ) , gdzie ϕ ′ jest monotoniczny. Następnie ϕ ( x 0 , … , x n -ϕ(x0,…,xn−1)

ϕ′(x0,…,xn−1,¬x0,…,¬xn−1),
ϕ′ jest tautologią wtedy i tylko wtedy, gdy implikacje monotoniczne T n t ( x 0 , … , x n - 1 ) → ϕ ′ ( x 0 , … , x n - 1 , N 0 , … , N n - 1 ) są ważne dla każdego t ≤ n , gdzie N i = T n - 1 t (ϕ(x0,…,xn−1)
Ttn(x0,…,xn−1)→ϕ′(x0,…,xn−1,N0,…,Nn−1)
t≤n
Ni=Ttn−1(x0,…,xi−1,xi+1,…,xn−1).

eTtnte′≤ete′⊨Ni↔¬xie′⊨ϕe′⊨ϕ′(x0,…,xn−1,N0,…,Nn−1)e⊨ϕ′(x0,…,xn−1,N0,…,Nn−1)


2δnpoly(l)kkk2δn+O(knlog⁡n)poly(l)δ≥1

k

ϕ=⋁i<l(⋀j∈Aixj∧⋀j∈Bi¬xj),
|Ai|+|Bi|≤kinn′=n/bb≈k−1nlog⁡nϕ
(∗)⋀u<n′Ttub(xbu,…,xb(u+1)−1)→⋁i<l(⋀j∈Aixj∧⋀j∈BiNj)
n′t0,…,tn′−1∈[0,b]j=bu+j′0≤j′<b
Nj=Ttub−1(xbu,…,xbu+j′−1,xbu+j′+1,…,xb(u+1)−1).
We can write Ttb as a monotone CNF of size O(2b), hence the LHS of (∗) is a monotone CNF of size O(n2b). On the right-hand side, we may write Nj as a monotone DNF of size O(2b). Thus, using distributivity, each disjunct of the RHS can be written as a monotone DNF of size O(2kb), and the whole RHS is a DNF of size O(l2kb). It follows that (∗) is an instance of our problem of size O(l2O(kb)) in n variables. By assumption, we may check its validity in time O(2δn+O(kb)lO(1)). We repeat this check for all bn′ choices of t→, thus the total time is
O((b+1)n/b2δn+O(kb)lO(1))=O(2δn+O(knlog⁡n)lO(1))
as claimed.

We get a tighter connection with the (S)ETH by considering the bounded-width version of the problem: for any k≥3, let k-MonImp denote the restriction of the problem where Φ is a k-CNF, and Ψ is a k-DNF. The (S)ETH concerns the constants

sk=inf{δ:k-SAT∈DTIME(2δn)},s∞=sup{sk:k≥3}.
Likewise, let us define
sk′=inf{δ:k-MonImp∈DTIME(2δn)},s∞′=sup{sk′:k≥3}.
Clearly,
s3′≤s4′≤⋯≤s∞′≤1
as in the SAT case. We also have
sk′≤sk,
and the double-variable reduction in the question shows
sk≤2sk′.
Now, if we apply the construction above with constant block-size b, we obtain
sk≤sbk′+log⁡(b+1)b,
hence
s∞=s∞′.
In particular, SETH is equivalent to s∞′=1, and ETH is equivalent to sk′>0 for all k≥3.

Thank you for your answer! I'm curious whether it is possible to make Φ and Ψ constant-depth in this construction? Namely, I'm not aware whether subexponential-size constant-depth monotone Boolean formulas (or even non-monotone circuits) are known for Tkn (in particular for Majority)? Of course there is a 2nΩ(1/d) lower bound for depth-d, but, say, 2n size would be OK.
— Sasha Kozachinskiy

Tkn, and in general anything computable by polynomial-size formulas (i.e., in NC^1), has depth-d circuits of size 2nO(1/d). See e.g. cstheory.stackexchange.com/q/14700 . I will have to think if you can make them monotone, but it sounds plausible.
— Emil Jeřábek 3.0

OK. First, the generic construction works fine in the monotone setting: if a function has poly-size monotone formulas, it has depth-d monotone circuits of size 2nO(1/d)poly(n) for any d≥2. Second, for Tkn specifically, it is easy to construct monotone depth-3 circuits of size 2O(nlog⁡n) by splitting the input into blocks of size Θ(nlog⁡n).
— Emil Jeřábek 3.0

Actually, pushing this idea a little bit more, it does provide an answer to the original question: assuming SETH, the lower bound holds already for Φ monotone CNF and Ψ monotone DNF. I will write it up later.
— Emil Jeřábek 3.0

I would guess that you can divide all the variables into about n blocks x1,…xn and then write Tk1n(x1)∧…∧Tknn(xn)→ϕ′ for every k1+…+kn≤n. You can use 2n-size CNF for every threshold function. But then on a right hand side you will have not DNF but a depth-3 formula...
— Sasha Kozachinskiy
Korzystając z naszej strony potwierdzasz, że przeczytałeś(-aś) i rozumiesz nasze zasady używania plików cookie i zasady ochrony prywatności.
Licensed under cc by-sa 3.0 with attribution required.